#include "CodaBase.h"

#ifndef __CODA__
#define __CODA__

template <class Elem> 
class Coda : public CodaBase<Elem> {
 private:
        Elem  *dati;
        int   MaxSize;
        int   CurSize;
 public:

        Coda(int ms);
        ~Coda();
        virtual bool enqueue(Elem e);
        virtual bool dequeue();
        virtual bool head(Elem &e);
        bool isempty();
};

template <class Elem> 
Coda<Elem>::Coda(int ms)
{
   MaxSize = ms;
   CurSize = 0;
   dati = new Elem[MaxSize];      
}

template <class Elem> 
Coda<Elem>::~Coda()
{
   delete[] dati;       
}

template <class Elem> 
bool Coda<Elem>::enqueue(Elem e)
{
     if (CurSize==MaxSize)
     {
        return false;                     
     }    
     
//     cout << CurSize << " " << e ;
     dati[CurSize] = e;
     CurSize++;
//     cout << CurSize << " " << endl ;
     
     return true;
};

template <class Elem> 
bool Coda<Elem>::dequeue() {
     
     if (CurSize==0) return false;
     
     for(int i=0; i<CurSize-1; i++)
            dati[i] = dati[i+1];
     CurSize = CurSize -1;
     // CurSize--;    
     return true;
};

template <class Elem> 
bool Coda<Elem>::head(Elem &e)
{
     if (CurSize>0)
     {
        e = dati[0]; 
        return true;
     } else return false;
};

template <class Elem> 
bool Coda<Elem>::isempty() {if (CurSize==0) return true; else return false;};      

#endif
